## dtkcore 5.6.12

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

set (DVERSION "5.6.8" CACHE STRING "define project version")

project (DtkCore
  VERSION ${DVERSION}
  DESCRIPTION "DTK Core module"
  HOMEPAGE_URL "https://github.com/linuxdeepin/dtkcore"
  LANGUAGES CXX C
)
message(STATUS ${PROJECT_VERSION})

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(QT_VERSION_MAJOR "5" CACHE STRING "Qt Version")
message("Current Qt Version: ${QT_VERSION_MAJOR}")

set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dtk${PROJECT_VERSION_MAJOR}/DCore")
set (TOOL_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/dtk${PROJECT_VERSION_MAJOR}/DCore/bin")
set (LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}")
set (MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "Install dir for qt pri files")
set (FEATURES_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/features" CACHE STRING "Install dir for qt prf files")
set (CONFIG_CMAKE_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/DtkCore" CACHE STRING "Install dir for cmake config files")

set (BUILD_EXAMPLES ON CACHE BOOL "Build examples")
option(BUILD_VERSION "buildversion" "0")
if(NOT BUILD_VERSION)
  set(BUILD_VERSION "0")
endif()

if(UNIX AND NOT APPLE)
  set(LINUX TRUE)
endif()
set (BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

set (BUILD_WITH_SYSTEMD OFF CACHE BOOL "Build with systemd")

# CXX FILAGS
if("${QT_VERSION_MAJOR}" STREQUAL "5")
  set(CMAKE_CXX_STANDARD 11)
else()
  set(CMAKE_CXX_STANDARD 17)
endif()
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

if(NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed -pie")
  if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
  endif ()
  string(REPLACE "-O3" "-Ofast" CMAKE_CXX_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
endif()

if (BUILD_DOCS)
  add_subdirectory(docs)
endif ()

add_subdirectory(src)
if(BUILD_TESTING)
  message("==================================")
  message("       Now Testing is enabled     ")
  message("==================================")
  enable_testing()
  add_subdirectory(tests)
endif()
if(BUILD_EXAMPLES)
  message("===================================")
  message("You can build and run examples now ")
  message("===================================")
  add_subdirectory(examples)
endif()
add_subdirectory(tools)
install(FILES cmake/DtkCMake/DtkCMakeConfig.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/DtkCMake")
install(FILES cmake/DtkTools/DtkToolsConfig.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/DtkTools")
install(FILES cmake/DtkTools/DtkSettingsToolsMacros.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/DtkTools")
install(FILES cmake/DtkDConfig/DtkDConfigConfig.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/DtkDConfig")

configure_package_config_file(misc/DtkCoreConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DtkCoreConfig.cmake
    INSTALL_DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
    PATH_VARS TOOL_INSTALL_DIR)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DtkCoreConfigVersion.cmake"
    VERSION ${DVERSION}
    COMPATIBILITY SameMajorVersion
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DtkCoreConfig.cmake DESTINATION ${CONFIG_CMAKE_INSTALL_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DtkCoreConfigVersion.cmake DESTINATION ${CONFIG_CMAKE_INSTALL_DIR})

configure_file(misc/dtkcore.pc.in dtkcore.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtkcore.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

configure_file(misc/qt_lib_dtkcore.pri.in qt_lib_dtkcore.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkcore.pri DESTINATION "${MKSPECS_INSTALL_DIR}")
install(FILES misc/dtk_install_dconfig.prf DESTINATION ${FEATURES_INSTALL_DIR})
set(CONFIGNAME include/global/dtkcore_config.h)
file(WRITE ${CONFIGNAME}
  "// it is auto make config\n"
  "#define DTK_VERSION_MAJOR ${PROJECT_VERSION_MAJOR}\n"
  "#define DTK_VERSION_MINOR ${PROJECT_VERSION_MINOR}\n"
  "#define DTK_VERSION_PATCH ${PROJECT_VERSION_PATCH}\n"
  "#define DTK_VERSION_BUILD ${BUILD_VERSION}\n"
  "#define DTK_VERSION_STR \"${PROJECT_VERSION}\"\n"
  "\n"
)
file(GLOB CONFIGSOURCE include/DtkCore/*)

foreach(FILENAME ${CONFIGSOURCE})
  get_filename_component(thefile ${FILENAME} NAME)
  file(APPEND ${CONFIGNAME} "#define DTKCORE_CLASS_${thefile}\n")
endforeach()

=== docs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

find_package (Doxygen REQUIRED)

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt${QT_VERSION_MAJOR}/doc CACHE STRING "QCH install location")

set (DOXYGEN_GENERATE_HTML YES CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML YES CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP YES CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.zh_CN.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.core")
set (DOXYGEN_QCH_FILE "dtkcore.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER "dtkcore")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)

set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://org.qt-project.qtcore/qtcore/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_IMAGE_PATH ${PROJECT_SOURCE_DIR}/docs/src)
set (DOXYGEN_SOURCE_BROWSE "YES")

set (BUILD_THEME OFF CACHE BOOL "Build doxgen theme")
if(BUILD_THEME)
if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/doxygen-theme")
message(STATUS "doxygen-theme exists")
else()
execute_process(COMMAND git clone https://github.com/linuxdeepin/doxygen-theme.git --depth=1
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        TIMEOUT 60
    )
execute_process(COMMAND bash themesetting.sh
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/doxygen-theme/
)
endif()
set (DOXYGEN_HTML_EXTRA_STYLESHEET "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome.css"
                                "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-sidebar-only.css"
                                "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-sidebar-only-darkmode-toggle.css"
                                )
set (DOXYGEN_HTML_EXTRA_FILES "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-darkmode-toggle.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-fragment-copy-button.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-paragraph-link.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-interactive-toc.js"
                            )
set (DOXYGEN_GENERATE_TREEVIEW "YES")
set (DOXYGEN_DISABLE_INDEX "NO")
set (DOXYGEN_FULL_SIDEBAR "NO")
set (DOXYGEN_HTML_HEADER "docs/doxygen-theme/doxygen-awesome-css/header.html")
set (DOXYGEN_HTML_FOOTER "docs/doxygen-theme/doxygen-awesome-css/footer.html")
endif()

set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_PREDEFINED
    "DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {"
    "DCORE_END_NAMESPACE=}}"
    "DCORE_USE_NAMESPACE=using namespace Dtk::Core;"
    "Q_OS_LINUX=1"
)
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${PROJECT_BINARY_DIR}/docs/html/dtkcore.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== src/CMakeLists.txt ===
#cmake_minimum_required(VERSION 3.5)
set(LIBNAME dtkcore)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set (DSG_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" CACHE STRING "PREFIX of DSG_DATA_DIRS")
add_definitions(-DPREFIX="${DSG_PREFIX_PATH}")
add_definitions(-DLIBDTKCORE_LIBRARY)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
if(LINUX)
  find_package(PkgConfig REQUIRED)
  find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)
  if("${QT_VERSION_MAJOR}" STREQUAL "5")
      pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt) #Dtk6 removed.
  endif()

  if("${QT_VERSION_MAJOR}" STREQUAL "6")
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core5Compat)
  endif()

  if(BUILD_WITH_SYSTEMD)
    pkg_check_modules(Systemd REQUIRED IMPORTED_TARGET libsystemd)
  endif()
endif()
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Xml)

# start text encoding
find_package(ICU REQUIRED COMPONENTS uc)
pkg_check_modules(uchardet REQUIRED uchardet)
# end text encoding

# start base
include(base/base.cmake)
# end base

# start dci
include(dci/dci.cmake)
#end dci

#start filesystem
include(filesystem/filesystem.cmake)
#end filesystem
# start log
include(log/log.cmake)
#end log
# start settings
include(settings/settings.cmake)
#end settings

#start utils
include(util/util.cmake)
#end utils

#GLOB
include(glob.cmake)
#endGLOG
if(LINUX)
  add_library(${LIBNAME} SHARED
    ${base_SRCS}
    ${dci_SRCS}
    ${filesystem_SRCS}
    ${log_SRCS}
    ${settings_SRC}
    ${utils_SRC}
    ${glob_SRC}
  )
  target_link_libraries(
    ${LIBNAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Xml
  )
  target_link_libraries(${LIBNAME} PRIVATE
    ICU::uc
    Qt${QT_VERSION_MAJOR}::CorePrivate
    uchardet
  )
  if("${QT_VERSION_MAJOR}" STREQUAL "6")
    target_link_libraries(${LIBNAME} PRIVATE
      Qt${QT_VERSION_MAJOR}::Core5Compat #TODO: [QTextCodec] : should remove this dependencies
    )
  endif()
  if("${QT_VERSION_MAJOR}" STREQUAL "5")
    target_link_libraries(${LIBNAME} PRIVATE
      PkgConfig::QGSettings
    )
  endif()
  if(BUILD_WITH_SYSTEMD)
    target_link_libraries(${LIBNAME} PRIVATE
      PkgConfig::Systemd
    )
    add_definitions(-DBUILD_WITH_SYSTEMD)
  endif()

else()
  add_library(${LIBNAME} SHARED
    ${base_SRCS}
    ${dci_SRCS}
    ${filesystem_SRCS}
    ${log_SRCS}
    ${settings_SRC}
    ${utils_SRC}
    ${glob_SRC}
  )
  target_link_libraries(
    ${LIBNAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Xml
  )
  target_link_libraries(${LIBNAME} PRIVATE
    ICU::uc
    Qt${QT_VERSION_MAJOR}::CorePrivate
    uchardet
  )
  if("${QT_VERSION_MAJOR}" STREQUAL "6")
    target_link_libraries(${LIBNAME} PRIVATE
      Qt${QT_VERSION_MAJOR}::Core5Compat
    )
  endif()
  if("${QT_VERSION_MAJOR}" STREQUAL "5")
    target_link_libraries(${LIBNAME} PRIVATE
      PkgConfig::QGSettings
    )
  endif()
endif()
set_target_properties(${LIBNAME} PROPERTIES
  VERSION ${CMAKE_PROJECT_VERSION}
  SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
  EXPORT_NAME Core
)
target_include_directories(${LIBNAME} PRIVATE
  ${uchardet_INCLUDE_DIRS}
)
target_include_directories(${LIBNAME} PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/util>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/dci>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/log>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/base>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/base/private>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/global>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/DtkCore>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/settings>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/filesystem>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)

target_include_directories(${LIBNAME} INTERFACE
  $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)

target_link_directories(${LIBNAME} INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:${LIBRARY_INSTALL_DIR}>
)

set(TOINSTALLBASE
  ../include/base/dobject.h
  ../include/base/dsingleton.h
  ../include/base/private/dobject_p.h
  ../include/base/derror.h
  ../include/base/dexpected.h
)
install(FILES ${TOINSTALLBASE} DESTINATION "${INCLUDE_INSTALL_DIR}")
install(DIRECTORY ../include/dci/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*.h")
install(DIRECTORY ../include/DtkCore/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/filesystem/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*.h")
install(DIRECTORY ../include/global/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*.h")
file(GLOB TOINSTALLLOG
  ../include/log/*.h
)
install(FILES ${TOINSTALLLOG} DESTINATION "${INCLUDE_INSTALL_DIR}")
file(GLOB TOINSTALLSETTINGS
  ../include/settings/*.h
  ../include/settings/backend/*.h
)

if(${QT_VERSION_MAJOR} STREQUAL "6")
  list(REMOVE_ITEM TOINSTALLSETTINGS "../include/settings/backend/qsettingbackend.h")
endif()

install(FILES ${TOINSTALLSETTINGS} DESTINATION "${INCLUDE_INSTALL_DIR}")
install(DIRECTORY ../include/util/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*.h")
install(TARGETS ${LIBNAME} EXPORT DtkCoreTargets
 DESTINATION ${LIBRARY_INSTALL_DIR})

install(EXPORT DtkCoreTargets
  FILE DtkCoreTargets.cmake
  NAMESPACE Dtk::
  DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
)

=== tests/CMakeLists.txt ===
set(BIN_NAME "ut-${PROJECT_NAME}")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
# dbus
set(CMAKE_CXX_FLAGS "-fno-access-control")
add_compile_options(-fsanitize=address)
add_link_options(-fsanitize=address)
add_definitions(-DPREFIX="${CMAKE_PREFIX_PATH}")
add_definitions(-DOS_VERSION_TEST_FILE="/tmp/etc/os-version")
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
if(LINUX)
  find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)
  find_package(PkgConfig REQUIRED)
  if("${QT_VERSION_MAJOR}" STREQUAL "5")
    pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
  endif()
  if(BUILD_WITH_SYSTEMD)
    pkg_check_modules(Systemd REQUIRED IMPORTED_TARGET libsystemd)
  endif()
endif()

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Xml)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Concurrent)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)
find_package(GTest REQUIRED)

if("${QT_VERSION_MAJOR}" STREQUAL "6")
  find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core5Compat)
endif()

# start base 
include(../src/base/base.cmake)

# end base

# start dci
include(../src/dci/dci.cmake)
#end dci

#start filesystem
include(../src/filesystem/filesystem.cmake)
#end filesystem
# start log 
include(../src/log/log.cmake)
#end log
# start settings 
include(../src/settings/settings.cmake)
#message(${settings_SRC})
#end settings

#start utils 

# TODO match linux and others
include(../src/util/util.cmake)
#end utils

#GLOB
include(../src/glob.cmake)

#endglob

# for test.so
add_subdirectory(./testso)

# test 
file(GLOB TEST_HEADER
  ut_.*h 
)
file(GLOB TEST_SOURCE
  *.cpp 
)

if("${QT_VERSION_MAJOR}" STREQUAL "6")
  list(REMOVE_ITEM TEST_SOURCE "${CMAKE_CURRENT_LIST_DIR}/ut_gsettingsbackend.cpp")
endif()

set(test_SRC 
  ${TEST_HEADER}
  ${TEST_SOURCE}
)

# end test
if(LINUX)
  add_executable(${BIN_NAME}
    ${base_SRCS}
    ${dci_SRCS}
    ${filesystem_SRCS}
    ${log_SRCS}	
    ${settings_SRC}
    ${utils_SRC}
    ${glob_SRC}
    ${test_SRC}
    ./data.qrc
  )
  add_dependencies(${BIN_NAME} vtabletest)
  target_link_libraries(
    ${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::CorePrivate
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Xml
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::Test
    ${GTEST_LIBRARIES}
    -lpthread
    -lm 
    -lgcov
    -lvtabletest
    -ldl
  )

  if(${QT_VERSION_MAJOR} STREQUAL "5")
      target_link_libraries(
        ${BIN_NAME} PRIVATE
        PkgConfig::QGSettings
      )
  endif()

  if(BUILD_WITH_SYSTEMD)
    target_link_libraries(
      ${BIN_NAME} PRIVATE
      PkgConfig::Systemd
    )
  endif()

  if("${QT_VERSION_MAJOR}" STREQUAL "6")
    target_link_libraries(${BIN_NAME} PRIVATE
      Qt${QT_VERSION_MAJOR}::Core5Compat
    )
  endif()
  if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
  endif()
  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
  endif()
  target_link_directories(${BIN_NAME} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/testso/)
  target_include_directories(${BIN_NAME} PUBLIC
    ../include/util/
    ../include/dci/
    ../include/log/
    ../include/base/
    ../include/base/private/
    ../include/global/
    ../include/DtkCore/
    ../include/settings/
    ../include/filesystem/
    ../include/
    ../src/filesystem/private/
    ./testso/
  )
else()
  add_executable(${BIN_NAME}
    ${base_SRCS}
    ${dci_SRCS}
    ${filesystem_SRCS}
    ${log_SRCS}
    ${settings_SRC}
    ${utils_SRC}
    ${glob_SRC}
    ${test_SRC}
    ./data.qrc
  )
  add_dependencies(${BIN_NAME} vtabletest)
  target_link_libraries(
    ${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::CorePrivate
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Xml
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::Test
    ${GTEST_LIBRARIES}
    -lpthread
    -lm 
    -lgcov
    -lvtabletest
  )
  if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
  endif()
  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
  endif()
  target_link_directories(${BIN_NAME} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/testso/)
  target_include_directories( ${BIN_NAME} PUBLIC
    ../include/util/
    ../include/dci/
    ../include/log/
    ../include/base/
    ../include/base/private/
    ../include/global/
    ../include/DtkCore/
    ../include/settings/
    ../include/filesystem/
    ../include/
    ./testso/
  )
endif()

add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== tools/CMakeLists.txt ===
add_subdirectory(dci)
add_subdirectory(deepin-os-release)
add_subdirectory(qdbusxml2cpp)
add_subdirectory(settings)
add_subdirectory(ch2py)

=== examples/dlog-example/CMakeLists.txt ===
set(BINNAME dlog)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)

add_executable(${BINNAME}
  main.cpp
)

target_link_libraries(
  ${BINNAME} PRIVATE
  Qt${QT_VERSION_MAJOR}::DBus
  dtkcore
)
target_include_directories(${BINNAME} PUBLIC
  ../../include/
)

=== examples/expintf-example/CMakeLists.txt ===
set(BINNAME exprintf)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)

add_executable(${BINNAME}
  main.cpp
)

target_link_libraries(
  ${BINNAME} PRIVATE 
  Qt${QT_VERSION_MAJOR}::DBus 
  dtkcore
)
target_include_directories(${BINNAME} PUBLIC
  ../../include/base
  ../../include/base/private/
  ../../include/filesystem/
  ../../include/
)

=== examples/filewatcher-example/CMakeLists.txt ===
set(BINNAME filewatcher)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

add_executable(${BINNAME}
    main.cpp
)

target_link_libraries(
    ${BINNAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    dtkcore
)

target_include_directories(${BINNAME} PUBLIC
    ../../include/filesystem/
    ../../include/
)

=== examples/textcodec-example/CMakeLists.txt ===
set(BINNAME textcodec)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

add_executable(${BINNAME}
    main.cpp
)

target_link_libraries(
    ${BINNAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    dtkcore
)

if("${QT_VERSION_MAJOR}" STREQUAL "6")
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core5Compat)
    target_link_libraries(
    ${BINNAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core5Compat
)
endif()

target_include_directories(${BINNAME} PUBLIC
    ../../include/util/
    ../../include/
)

=== tests/testso/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Uniontech Software Technology Co.,Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE TESTSO "*.cpp" "*.h")

add_compile_options(-fno-sanitize=all)
add_link_options(-fno-sanitize=all)

add_library(vtabletest SHARED ${TESTSO})

target_link_libraries(vtabletest PUBLIC Qt${QT_VERSION_MAJOR}::Core)

=== tools/ch2py/CMakeLists.txt ===
set(BIN_NAME ch2py)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

set(CMAKE_AUTORCC ON)
add_executable(${BIN_NAME}
    ${PROJECT_SOURCE_DIR}/src/util/dpinyin.cpp
    ${PROJECT_SOURCE_DIR}/src/util/util.qrc
    main.cpp
)
target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
)
target_include_directories(${BIN_NAME} PRIVATE
    ${PROJECT_SOURCE_DIR}/include/util
    ${PROJECT_SOURCE_DIR}/include/global
)

install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== tools/dci/CMakeLists.txt ===
set(BIN_NAME dci)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
add_definitions(-DDTK_NO_PROJECT)
# start dci
include(../../src/dci/dci.cmake)
add_executable(${BIN_NAME}
  ${dci_SRCS}
  main.cpp
)
target_link_libraries(${BIN_NAME} PRIVATE
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::CorePrivate
)
target_include_directories(${BIN_NAME} PUBLIC
  ../../include/
  ../../include/dci/
  ../../include/DtkCore/
  ../../include/base/
  ../../include/global/
)
#end dci

install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== debian/changelog ===
dtkcore (5.6.12-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 10 Oct 2023 15:35:08 +0800

dtkcore (5.6.12) unstable; urgency=medium

  * Release 5.6.12
  * add DLicenseInfo 
  * cached memoryInstalledSize
  * FIX developer-center#4348

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 15 May 2023 11:18:15 +0800

dtkcore (5.6.11) unstable; urgency=medium

  * Release 5.6.11
  * add color to ConsoleAppender
  * remove build warning
  
 -- Deepin Packages Builder <packages@deepin.com>  Mon, 08 May 2023 11:48:45 +0800

dtkcore (5.6.10) unstable; urgency=medium

  * Release 5.6.10
  * support XDG_SESSION_DESKTOP set to DDE

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 17 Apr 2023 17:08:28 +0800

dtkcore (5.6.9) unstable; urgency=medium

  * Release 5.6.9

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 03 Apr 2023 09:48:07 +0800

dtkcore (5.6.8) unstable; urgency=medium

  * Release 5.6.8

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 22 Feb 2023 14:09:56 +0800

dtkcore (5.6.6) unstable; urgency=medium

  * Release 5.6.6

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 21 Feb 2023 12:25:24 +0800

dtkcore (5.6.5) unstable; urgency=medium

  * Release 5.6.5

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 02 Feb 2023 14:25:36 +0800

=== debian/control ===
Source: dtkcore
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper-compat ( =12), pkg-config,
 qttools5-dev-tools, qtbase5-private-dev, doxygen,
 libgsettings-qt-dev, libgtest-dev, libdtkcommon-dev, cmake,
 libuchardet-dev, libicu-dev, libsystemd-dev
Standards-Version: 3.9.8

Package: libdtkcore5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lshw, libdtkcommon
Multi-Arch: same
Description: Deepin Tool Kit Core library
 DtkCore is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkcore5-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkcore5( =${binary:Version})
Description: Deepin Tool Kit Core Utilities
 DtkCore is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the utilities of DtkCore

Package: libdtkcore-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkcore5( =${binary:Version}), libdtkcommon-dev(>=5.6.4)
Description: Deepin Tool Kit Core Devel library
 DtkCore is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries of DtkCore

Package: libdtkcore-doc
Architecture: any
Description: Deepin Tool Kit Core (document)
 DtkCore is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the doc files of DtkCore

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5
export DEB_CXXFLAGS_MAINT_APPEND = -Ofast

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
# Fix: invalid digit "8" in octal constant. e.g.  u008 ==> 008 ==> 8
BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DBUILD_VERSION=$(BUILD_VER) -DDVERSION=$(PACK_VER) -DD_DSG_APP_DATA_FALLBACK=/var/dsg/appdata -DBUILD_WITH_SYSTEMD=ON

#override_dh_auto_test:
#	echo "skip auto test"

override_dh_makeshlibs:
	dh_makeshlibs -V "libdtkcore5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"

## dtkcore 5.6.32

=== debian/changelog ===
dtkcore (5.6.32) unstable; urgency=medium

  * refactor: log files move to dtklog(Issue: #182)

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 08 Jul 2024 02:29:21 +0000

dtkcore (5.6.31) unstable; urgency=medium

  * chore: use '&&' and '||' instead of 'and' and 'or'

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 27 Jun 2024 09:11:34 +0000

dtkcore (5.6.30) unstable; urgency=medium

  * feat: 允许基于dtk开发的应用动态控制其日志输出等级(Task: 307567)(Influence: 允许基于dtk开发的应用动态控制其日志输出等级)
  * fix: lshw查询内存大小时返回多元素数组,修正解析过程(Bug: 228681)(Influence: DSysInfo::memoryInstalledSize解析过程)
  * fix: 从文件中读取deepinType和productType值时因为权限问题会失败(Influence: 正常显示版本和说明)
  * feat: 增加registerLoggingRulesWatcher接口(Task: 303379)
  * fix: 修复计算 build 版本号错误的问题(Influence: 构建版本号（BUILD_VERSION ）)
  * feat: DeepinType类型增加军用版(Task: 316703)(Influence: DeepinType类型)
  * fix: 修复日志格式时间戳显示异常问题(Bug: 236239)(Influence: 使用DLogManager的应用日志输出格式)
  * chore: loggingrules config move to preference
  * refactor: remove LoggingRules interface
  * fix: crashed when access DSGApplication::id early
  * chore: fallback to dsgconfig value
  * fix(build): build faild on Qt 6.7.1

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 30 May 2024 02:46:32 +0000

dtkcore (5.6.29) unstable; urgency=medium

  * chore: remove warning for dbusxml2cpp in qt6

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 13 May 2024 03:02:53 +0000

dtkcore (5.6.28) unstable; urgency=medium

  * fix: fix undefined reference errors on spdlog 1.14.0
    Thanks to hillwoodroc

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 29 Apr 2024 08:23:39 +0000

dtkcore (5.6.27) unstable; urgency=medium

  * fix: lossing value when save DConfig
  * fix(qdbusxml2cpp): support qt 6.7

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 19 Apr 2024 08:55:35 +0000

dtkcore (5.6.26) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 26 Mar 2024 05:47:35 +0000

dtkcore (5.6.25) unstable; urgency=medium

  * chore: fix docs typo
  * feat: support to set appId for DConfig
  * fix: DConfig add check for name(Issue: #1211374)

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 11 Mar 2024 01:16:26 +0000

dtkcore (5.6.22) unstable; urgency=medium

  * Release 5.6.22

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 10 Jan 2024 02:30:59 +0000

dtkcore (5.6.21) unstable; urgency=medium

  * fix: app blocked when AM is unavailable
  * chore: remove decltype(auto) for dutil
  * chore: fix relative path invalid link
  * feat: allow skip including headers of annotations(Issue: #147)

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 09 Jan 2024 01:45:43 +0000

dtkcore (5.6.20) unstable; urgency=medium

  * feat: add utils function
  * chore: Implement DSGApplication::getId
  * feat(dstandardpaths): add XDG_STATE_HOME
  * chore: keep order when deduplication
  * fix: log files limit not work
  * chore: add dtk dbus generate function

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 28 Nov 2023 05:40:53 +0000

dtkcore (5.6.19) unstable; urgency=medium

  * fix: Type error for qdbusxml2cpp
  * fix: correct Dtk6SettingsToolsMacros.cmake path
  * chore: add flag UserPublic(Issue: https://github.com/linuxdeepin/developer-center/issues/5928)

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 23 Oct 2023 07:33:19 +0000

dtkcore (5.6.18) unstable; urgency=medium

  * fix: Can't clear cache when reset for DConfig in FileBackend
  * feat: Add isDefaultValue for DConfig(Issue: #3)
  * fix: Compiling failed in lower libspdlog-dev
  * fix: missing parameter passing for synchronization
  * fix(build): skip failed unit test
  * chore(tools): show help if argc < 2
  * fix: Compiling failed in libspdlog-dev before 1.4.0
    Thanks to Shiroko
  * fix: cmake failure when env is null
  * chore: correct typos in DtkSettingsToolsMacros.cmake
    Thanks to Felix Yan
  * chore: dpinyin tweak(Issue: #109)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 18 Oct 2023 06:01:45 +0000

dtkcore (5.6.17) unstable; urgency=medium

  * Release 5.6.17

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 08 Sep 2023 15:12:36 +0800

dtkcore (5.6.16) unstable; urgency=medium

  * fix: FileAppender log level not set
  * chore: ut linked dtkcore instead of source code
  * chore: tweak CMakeLists
  * chore: support Qt 6.4 build
  * chore: qch docs tweak
  * chore: add DtkBuildHelper depends
  * chore: console with color at tty
  * fix: missing dependency qttools5-dev
  * feat: add synchronization workflow

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 22 Aug 2023 06:13:45 +0000

dtkcore (5.6.15) unstable; urgency=medium

  * chore: dlog example tweak

 -- Yixue Wang <wangyixue@deepin.org>  Fri, 11 Aug 2023 13:42:20 +0800

dtkcore (5.6.14) unstable; urgency=medium

  * chore: function need to be marked as override
  * chore: ignore doxygen-theme folder
    Thanks to Skye-rs
  * chore: change OUTPUT_DIR variable in cmake
  * chore: remove unused pro files
  * refactor!: deprecate some interfaces in dtk6
  * fix: updateProp cannot convert to property type
  * fix: typo in xdg
  * chore: reduce compilation warnings
    Thanks to SPUER(Issue: #96)
  * chore(dcapmanager): RuntimeTime -> RuntimeDir
  * chore: Sync by https://github.com/linuxdeepin/.github/commit/559e91167d4919644f37bbcf123eb0651c1528ea(Influence: none)
  * chore: make test-recoverage.sh runable again
  * chore: add ut for DDbusSender
  * feat: add systembus send support
  * fix: internalPropSet nerver emit propertyChanged
  * chore: should include QVector headers
  * chore: dsysinfo tweak
  * chore: add some unit test

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 27 Jul 2023 06:56:33 +0000

dtkcore (5.6.13) unstable; urgency=medium

  * feat: DConfig add check for no existed item when override
  * fix(cmake): wrong use of option and wrong macro


=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5
export DEB_CXXFLAGS_MAINT_APPEND = -Ofast

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')

# Calculate build version:
# 5.6.8 -> 0; 5.6.8.7 -> 7; 5.6.8+u001 -> 1; 5.6.8.7+u001 -> 7; 5.6.8.0+u001 -> 0
BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}' | awk -F'.' '{print $$4}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')
ifeq ($(BUILD_VER), 0)
ifeq ($(shell expr $(shell echo "$(VERSION)" | awk -F. '{print NF-1}') '<' 3), 1)
	BUILD_VER=$(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}'  | sed 's/[^0-9]//g' | awk '{print int($$1)}')
endif
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DBUILD_VERSION=$(BUILD_VER) -DDTK_VERSION=$(PACK_VER) -DD_DSG_APP_DATA_FALLBACK=/var/dsg/appdata

#override_dh_auto_test:
#	echo "skip auto test"

override_dh_makeshlibs:
	dh_makeshlibs -V "libdtkcore5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"

## dtkcore 5.7.1

=== debian/changelog ===
dtkcore (5.7.1) unstable; urgency=medium

  * feat: 增加智能终端设备类型 (#434)
    Thanks to Whale107
  * fix: remove unnecessary link libraries
  * fix: DDBusInterface signal loss
  * fix(util): error appid from `getAppIdFromAbsolutePath`

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 16 Oct 2024 03:30:45 +0000

dtkcore (5.6.34) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 20 Aug 2024 05:03:51 +0000

## dtkcore 5.7.5

=== debian/changelog ===
dtkcore (5.7.5) unstable; urgency=medium

  * fix: pidfd leak

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 12 Dec 2024 03:03:54 +0000

dtkcore (5.7.4) unstable; urgency=medium

  * fix: hasVtable is incorrect when destructing

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 03 Dec 2024 02:00:45 +0000

dtkcore (5.7.3) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 20 Nov 2024 02:19:06 +0000

dtkcore (5.7.2) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 13 Nov 2024 01:53:26 +0000

## dtkcore 5.7.9

=== debian/changelog ===
dtkcore (5.7.9-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 11 Feb 2025 15:11:16 -0500

dtkcore (5.7.9-1~exp2) experimental; urgency=medium

  * debian/control: Let libdtkcore-dev Breaks+Replaces:
    libdtkcommon-dev (<< 5.7.5). (Closes: #1095715)

 -- Boyuan Yang <byang@debian.org>  Tue, 11 Feb 2025 11:50:59 -0500

dtkcore (5.7.9-1~exp1) experimental; urgency=medium

  * New upstream release 5.7.9.
  * debian/libdtkcore5.shlibs: Require library version (>= 5.7).
  * debian/control: Require dtkcommon (>= 5.7.9) for dtklog.
  * Upload to experimental.
  * debian/patches: Dropped, not needed.
  * debian/rules: Enable -DBUILD_WITY_SYSTEMD.
  * debian/libdtkcore5-bin.install: Updated.

 -- Boyuan Yang <byang@debian.org>  Mon, 10 Feb 2025 19:36:21 -0500

=== debian/control ===
Source: dtkcore
Section: libs
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Yanhao Mo <yanhaocs@gmail.com>,
 Arun Kumar Pariyar <arun@debian.org>,
 Tu Qinggang <tuqinggang@uniontech.com>,
 Clay Stan <claystan97@gmail.com>,
 Hu Feng <hufeng@uniontech.com>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 cmake,
 doxygen <!nodoc>,
 libchardet-dev,
 libdtkcommon-dev (>= 5.7.9-2~),
 libgsettings-qt-dev,
 libgtest-dev,
 libicu-dev,
 libuchardet-dev,
 pkgconf,
 qtbase5-private-dev,
 qttools5-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/linuxdeepin/dtkcore
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkcore.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkcore

Package: libdtkcore-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libdtkcommon-dev (>= 5.7.6),
 libdtkcore5 (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libdtkcommon-dev (<< 5.7.5),
 libdtkwidget-dev (<< 5.2.2.10-1),
Replaces:
 libdtkcommon-dev (<< 5.7.5),
 libdtkwidget-dev (<< 5.2.2.10-1),
Description: Deepin Tool Kit Core library (development files)
 DtkCore is a base library for Deepin Qt/C++ applications.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the header files and static libraries of DtkCore.

Package: libdtkcore5
Architecture: any
Multi-Arch: same
Depends:
 libdtkcommon,
 lshw,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Core library
 DtkCore is a base library of Deepin Qt/C++ applications.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the shared libraries.

Package: libdtkcore5-bin
Architecture: any
Section: utils
Depends:
 libdtkcore5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 dtkcore-bin,
Description: Deepin Tool Kit Core library (utilities)
 DtkCore is a base devel library for Deepin Qt/C++ applications.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains various command-line utilities used by Deepin Tool Kit
 and other Deepin software. Some tools were originally provided by DtkSettings.

## dtkcore 5.7.11

=== debian/changelog ===
dtkcore (5.7.11-2) unstable; urgency=medium

  * debian/control: Add explicit build-dep libdtklog-dev.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 22:16:17 -0500

dtkcore (5.7.11-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 13:28:20 -0500

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,8 @@
  cmake,
  doxygen <!nodoc>,
  libchardet-dev,
- libdtkcommon-dev (>= 5.7.9-2~),
+ libdtkcommon-dev (>= 5.7.11),
+ libdtklog-dev,
  libgsettings-qt-dev,
  libgtest-dev,
  libicu-dev,
@@ -25,7 +26,7 @@
  qttools5-dev,
  qttools5-dev-tools,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/linuxdeepin/dtkcore
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkcore.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkcore
